var Rek = {
    
    // constants
    CONST: {
        DEBUG: false,

        COUNTRIES: [["1","UNITED STATES","US"],["2","UNITED KINGDOM","GB"],["3","AFGHANISTAN","AF"],["4","ALAND ISLANDS","AX"],["5","ALBANIA","AL"],["6","ALGERIA","DZ"],["7","AMERICAN SAMOA","AS"],["8","ANDORRA","AD"],["9","ANGOLA","AO"],["10","ANGUILLA","AI"],["11","ANTARCTICA","AQ"],["12","ANTIGUA AND BARBUDA","AG"],["13","ARGENTINA","AR"],["14","ARMENIA","AM"],["15","ARUBA","AW"],["16","AUSTRALIA","AU"],["17","AUSTRIA","AT"],["18","AZERBAIJAN","AZ"],["19","BAHAMAS","BS"],["20","BAHRAIN","BH"],["21","BANGLADESH","BD"],["22","BARBADOS","BB"],["23","BELARUS","BY"],["24","BELGIUM","BE"],["25","BELIZE","BZ"],["26","BENIN","BJ"],["27","BERMUDA","BM"],["28","BHUTAN","BT"],["29","BOLIVIA","BO"],["30","BOSNIA AND HERZEGOVINA","BA"],["31","BOTSWANA","BW"],["32","BOUVET ISLAND","BV"],["33","BRAZIL","BR"],["34","BRITISH INDIAN OCEAN TERRITORY","IO"],["35","BRUNEI DARUSSALAM","BN"],["36","BULGARIA","BG"],["37","BURKINA FASO","BF"],["38","BURUNDI","BI"],["39","CAMBODIA","KH"],["40","CAMEROON","CM"],["41","CANADA","CA"],["42","CAPE VERDE","CV"],["43","CAYMAN ISLANDS","KY"],["44","CENTRAL AFRICAN REPUBLIC","CF"],["45","CHAD","TD"],["46","CHILE","CL"],["47","CHINA","CN"],["48","CHRISTMAS ISLAND","CX"],["49","COCOS (KEELING) ISLANDS","CC"],["50","COLOMBIA","CO"],["51","COMOROS","KM"],["52","CONGO","CG"],["53","COOK ISLANDS","CK"],["54","COSTA RICA","CR"],["55","COTE D'IVOIRE","CI"],["56","CROATIA","HR"],["57","CUBA","CU"],["58","CYPRUS","CY"],["59","CZECH REPUBLIC","CZ"],["60","DENMARK","DK"],["61","DJIBOUTI","DJ"],["62","DOMINICA","DM"],["63","DOMINICAN REPUBLIC","DO"],["64","ECUADOR","EC"],["65","EGYPT","EG"],["66","EL SALVADOR","SV"],["67","EQUATORIAL GUINEA","GQ"],["68","ERITREA","ER"],["69","ESTONIA","EE"],["70","ETHIOPIA","ET"],["71","FALKLAND ISLANDS (MALVINAS)","FK"],["72","FAROE ISLANDS","FO"],["73","FIJI","FJ"],["74","FINLAND","FI"],["75","FRANCE","FR"],["76","FRENCH GUIANA","GF"],["77","FRENCH POLYNESIA","PF"],["78","FRENCH SOUTHERN TERRITORIES","TF"],["79","GABON","GA"],["80","GAMBIA","GM"],["81","GEORGIA","GE"],["82","GERMANY","DE"],["83","GHANA","GH"],["84","GIBRALTAR","GI"],["85","GREECE","GR"],["86","GREENLAND","GL"],["87","GRENADA","GD"],["88","GUADELOUPE","GP"],["89","GUAM","GU"],["90","GUATEMALA","GT"],["91","GUERNSEY","GG"],["92","GUINEA","GN"],["93","GUINEA-BISSAU","GW"],["94","GUYANA","GY"],["95","HAITI","HT"],["96","HEARD ISLAND AND MCDONALD ISLANDS","HM"],["97","HOLY SEE (VATICAN CITY STATE)","VA"],["98","HONDURAS","HN"],["99","HONG KONG","HK"],["100","HUNGARY","HU"],["101","ICELAND","IS"],["102","INDIA","IN"],["103","INDONESIA","ID"],["104","IRAN","IR"],["105","IRAQ","IQ"],["106","IRELAND","IE"],["107","ISLE OF MAN","IM"],["108","ISRAEL","IL"],["109","ITALY","IT"],["110","JAMAICA","JM"],["111","JAPAN","JP"],["112","JERSEY","JE"],["113","JORDAN","JO"],["114","KAZAKHSTAN","KZ"],["115","KENYA","KE"],["116","KIRIBATI","KI"],["117","NORTH KOREA","KP"],["118","SOUTH KOREA","KR"],["119","KUWAIT","KW"],["120","KYRGYZSTAN","KG"],["121","LAO PEOPLE'S DEMOCRATIC REPUBLIC","LA"],["122","LATVIA","LV"],["123","LEBANON","LB"],["124","LESOTHO","LS"],["125","LIBERIA","LR"],["126","LIBYAN ARAB JAMAHIRIYA","LY"],["127","LIECHTENSTEIN","LI"],["128","LITHUANIA","LT"],["129","LUXEMBOURG","LU"],["130","MACAO","MO"],["131","MACEDONIA","MK"],["132","MADAGASCAR","MG"],["133","MALAWI","MW"],["134","MALAYSIA","MY"],["135","MALDIVES","MV"],["136","MALI","ML"],["137","MALTA","MT"],["138","MARSHALL ISLANDS","MH"],["139","MARTINIQUE","MQ"],["140","MAURITANIA","MR"],["141","MAURITIUS","MU"],["142","MAYOTTE","YT"],["143","MEXICO","MX"],["144","MICRONESIA","FM"],["145","MOLDOVA","MD"],["146","MONACO","MC"],["147","MONGOLIA","MN"],["148","MONTENEGRO","ME"],["149","MONTSERRAT","MS"],["150","MOROCCO","MA"],["151","MOZAMBIQUE","MZ"],["152","MYANMAR","MM"],["153","NAMIBIA","NA"],["154","NAURU","NR"],["155","NEPAL","NP"],["156","NETHERLANDS","NL"],["157","NETHERLANDS ANTILLES","AN"],["158","NEW CALEDONIA","NC"],["159","NEW ZEALAND","NZ"],["160","NICARAGUA","NI"],["161","NIGER","NE"],["162","NIGERIA","NG"],["163","NIUE","NU"],["164","NORFOLK ISLAND","NF"],["165","NORTHERN MARIANA ISLANDS","MP"],["166","NORWAY","NO"],["167","OMAN","OM"],["168","PAKISTAN","PK"],["169","PALAU","PW"],["170","PALESTINIAN TERRITORY","PS"],["171","PANAMA","PA"],["172","PAPUA NEW GUINEA","PG"],["173","PARAGUAY","PY"],["174","PERU","PE"],["175","PHILIPPINES","PH"],["176","PITCAIRN","PN"],["177","POLAND","PL"],["178","PORTUGAL","PT"],["179","PUERTO RICO","PR"],["180","QATAR","QA"],["181","REUNION","RE"],["182","ROMANIA","RO"],["183","RUSSIAN FEDERATION","RU"],["184","RWANDA","RW"],["185","SAINT BARTHELEMY","BL"],["186","SAINT HELENA \/ ASCENSION \/ TRISTAN DA CUNHA",""],["187","SAINT KITTS AND NEVIS","KN"],["188","SAINT LUCIA","LC"],["189","SAINT MARTIN","MF"],["190","SAINT PIERRE AND MIQUELON","PM"],["191","SAINT VINCENT AND THE GRENADINES","VC"],["192","SAMOA","WS"],["193","SAN MARINO","SM"],["194","SAO TOME AND PRINCIPE","ST"],["195","SAUDI ARABIA","SA"],["196","SENEGAL","SN"],["197","SERBIA","RS"],["198","SEYCHELLES","SC"],["199","SIERRA LEONE","SL"],["200","SINGAPORE","SG"],["201","SLOVAKIA","SK"],["202","SLOVENIA","SI"],["203","SOLOMON ISLANDS","SB"],["204","SOMALIA","SO"],["205","SOUTH AFRICA","ZA"],["206","SOUTH GEORGIA","GS"],["207","SPAIN","ES"],["208","SRI LANKA","LK"],["209","SUDAN","SD"],["210","SURINAME","SR"],["211","SVALBARD AND JAN MAYEN","SJ"],["212","SWAZILAND","SZ"],["213","SWEDEN","SE"],["214","SWITZERLAND","CH"],["215","SYRIAN ARAB REPUBLIC","SY"],["216","TAIWAN","TW"],["217","TAJIKISTAN","TJ"],["218","TANZANIA","TZ"],["219","THAILAND","TH"],["220","TIMOR-LESTE","TL"],["221","TOGO","TG"],["222","TOKELAU","TK"],["223","TONGA","TO"],["224","TRINIDAD AND TOBAGO","TT"],["225","TUNISIA","TN"],["226","TURKEY","TR"],["227","TURKMENISTAN","TM"],["228","TURKS AND CAICOS ISLANDS","TC"],["229","TUVALU","TV"],["230","UGANDA","UG"],["231","UKRAINE","UA"],["232","UNITED ARAB EMIRATES","AE"],["233","UNITED STATES MINOR OUTLYING ISLANDS","UM"],["234","URUGUAY","UY"],["235","UZBEKISTAN","UZ"],["236","VANUATU","VU"],["237","VENEZUELA","VE"],["238","VIET NAM","VN"],["239","VIRGIN ISLANDS - BRITISH","VG"],["240","VIRGIN ISLANDS - US","VI"],["241","WALLIS AND FUTUNA","WF"],["242","WESTERN SAHARA","EH"],["243","YEMEN","YE"],["244","ZAMBIA","ZM"],["245","ZIMBABWE","ZW"]],

        STATUS_UNAVAILABLE:0,
        STATUS_LOGGED_OUT:1,
        STATUS_LOGGED_IN:2,
        STATUS_ACTIVE_SESSION:3,
        STATUS_NOT_READY:4,
        STATUS_FIRSTRUN:5,

        SIDEBAR_UNAVAILABLE:0,
        SIDEBAR_SIGNUP:1,
        SIDEBAR_LOGIN:2,
        SIDEBAR_CUR_ACTIVE:3,
        SIDEBAR_APP:4,

        SIDEBARTAB_REK:0,
        SIDEBARTAB_BMARK:1,
        SIDEBARTAB_BROWSE:2,
        SIDEBARTAB_SEARCH:3,
        SIDEBARTAB_FRIEND:4,
        SIDEBARTAB_ACCOUNT:5,

        DEFAULT_PREFS: {}
    },

    // module/namespace management
    namespaces: [],
    ns: function(fn) {
        var ns = {};
        Rek.namespaces.push(fn,ns);
        return ns;
    },
    
    UUID: '{00216216-1e97-4e87-9e63-148037b6bd71}',
    VERSION: null,

    // XPCOM components
    console: null,
    wm: null,
    browser: null,
    PREF: null,
    loginManager: null,
    nsLoginInfo: null,
    properties: null,

    //member variables
    doSkipPulse: false,

    // sidebar
    sidebar: null,
    sidebarChromeWindow: null,

    status: null,
    pulse: null,
    lastLoginID: null,
    lastLoginPass: null,

    // user object
    user: null,

    // preferences crc
    prefCrc: null,
    
    // ready
    ready: false,

    onload:function() {
        //var el = window.getElementById('urlbar');
        Rek.init();
    },
    onunload: function() {
        Rek.log('Rek unload');
        clearInterval(Rek.pulse);
        if (Rek.user.id) Rek.logout();
        Rek.db.flush();
        window.removeEventListener("unload", Rek.onload, false);
        window.removeEventListener("load", Rek.onunload, false);
    },
    init: function() {
        // namespaces
        for (var i=0; i<Rek.namespaces.length; i+=2) {
            var fn = Rek.namespaces[i];
            var ns = Rek.namespaces[i+1];
            fn.apply(ns);
        }

        // initialize XPCOM components
        Rek.console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
        Rek.wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
        //Rek.browser = Rek.wm.getMostRecentWindow('navigator:browser');
        //alert(gBrowser);
        
        Rek.browser = window;
        //Rek.console.logStringMessage(window.gBrowser);
        //Rek.console.logStringMessage(Rek.browser);
        //Rek.pref = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch2);
        Rek.PREF = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch('extensions.rekommend.');
        Rek.loginManager = Components.classes['@mozilla.org/login-manager;1'].getService(Components.interfaces.nsILoginManager);
        Rek.nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Components.interfaces.nsILoginInfo,"init");
        if (typeof(JSON) == "undefined") {
            Components.utils.import("resource://gre/modules/JSON.jsm");
            JSON.parse = JSON.fromString;
            JSON.stringify = JSON.toString;
        }

        // initialize preferences if not present
        try {
            var uid = Rek.PREF.getCharPref('userid');
        } catch (e) {
            Rek.PREF.setCharPref('userid','');
            Rek.PREF.setBoolPref('remember',false);
        }

        // properties
        Rek.properties = document.getElementById("rek-properties");

        // toolbar button
        // add button to toolbar
        try {
            var myId    = "rek-toolbarbutton"; // ID of button to add
            var beforeId = "urlbar-container";    // ID of element to insert before
            var navBar  = document.getElementById("nav-bar");
            var curSet  = navBar.currentSet.split(",");
            if (curSet.indexOf(myId) == -1) {
                var pos = curSet.indexOf(beforeId) || curSet.length;
                var set = curSet.slice(0, pos).concat(myId).concat(curSet.slice(pos));
                navBar.setAttribute("currentset", set.join(","));
                navBar.currentSet = set.join(",");
                document.persist(navBar.id, "currentset");
                try {
                    BrowserToolboxCustomizeDone(true);
                }
                catch (e) {
                // do nothing
                }
            }
        }
        catch(e) {
        // do nothing
        }
        
        // firstrun / version support
        // MOZILLA extension observer
        var observer = {
            uninstall: null,
            init: function() {
                try {
                    // FF4
                    Components.utils.import("resource://gre/modules/AddonManager.jsm");
                    AddonManager.addAddonListener(this);
                } catch(e) {
                // not FF4
                }
                this.register();
            },
            register: function() {
                var o = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
                if (o != null) {
                    o.addObserver(this,'em-action-requested',false);
                    //o.addObserver(this, 'quit-application-requested', false);
                    o.addObserver(this,'quit-application-granted',false);
                }
            },
            unregister: function() {
                var o = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
                if (o != null) {
                    o.removeObserver(this,'em-action-requested');
                    //o.removeObserver(this, 'quit-application-requested');
                    o.removeObserver(this,'quit-application-granted');
                }
            },
            observe: function(subject,topic,data) {
                if (topic == 'em-action-requested') {
                    subject.QueryInterface(Components.interfaces.nsIUpdateItem);
                    if (subject.id == Rek.UUID) {
                        switch (data) {
                            case 'item-uninstalled':
                                this.uninstall = true;
                                break;
                            case 'item-cancel-action':
                                this.uninstall = false;
                                break;
                            default:
                        }
                    }
                } else if (topic == 'quit-application-granted') {
                    if (this.uninstall) {
                        Rek.PREF.deleteBranch('');
                    }
                    this.unregister();
                }
            },
            onUninstalling: function(addon) {
                if (addon.id == Rek.UUID) {
                    this.uninstall = true;
                }
            },
            onOperationCancelled: function(addon) {
                if (addon.id == Rek.UUID) {
                    this.uninstall = (addon.pendingOperations & AddonManager.PENDING_UNINSTALL) != 0;
                }
            }
        };
        observer.init();

        // first run
        var ver,firstrun;

        // fetch/initialize the firstrun prefs
        try {
            ver = Rek.PREF.getCharPref('version');
            firstrun = Rek.PREF.getBoolPref('firstrun');
        } catch(e) {
            ver = '0.0.0';
            firstrun = true;
        }

        if (typeof Components.classes["@mozilla.org/extensions/manager;1"] == 'undefined') {
            // FF4 +
            if (typeof AddonManager == 'undefined') {
                Components.utils.import("resource://gre/modules/AddonManager.jsm");
            }
            AddonManager.getAddonByID(Rek.UUID,function(addon){
                if (addon) {
                    Rek.VERSION = addon.version;
                    if (firstrun){
                        Rek.PREF.setBoolPref('firstrun',false);
                        Rek.PREF.setCharPref('version',Rek.VERSION);

                        // Insert code for first run here
                        
                    } else  if (ver != Rek.VERSION) {
                        Rek.PREF.setCharPref('version',Rek.VERSION);

                        // Insert code if version is different here => upgrade
                        
                    }
                }
            });
        } else {
            //  < FF4
            var xm = Components.classes['@mozilla.org/extensions/manager;1'].getService(Components.interfaces.nsIExtensionManager);
            var addon = xm.getItemForID(Rek.UUID);
            if (addon) {
                Rek.VERSION = addon.version;
                if (firstrun){
                    Rek.PREF.setBoolPref('firstrun',false);
                    Rek.PREF.setCharPref('version',Rek.VERSION);

                    // Insert code for first run here
                    
                } else  if (ver!=Rek.VERSION) {
                    Rek.PREF.setCharPref('version',Rek.VERSION);

                    // Insert code if version is different here => upgrade
                    
                }
            }
        }

        // db module
        this.db.init();

        // user object
        this.user = Rek.nullUser();
        
        // validate internet/db status
        Rek.validateStatus('init');
        
        // set default status
        Rek.status = Rek.CONST.STATUS_NOT_READY;
        
        // get login information from nsIPrefBranch2/nsILoginManager
        var logins,userid,password;
        userid = Rek.PREF.getCharPref('userid');

        logins = Rek.loginManager.findLogins({},'chrome://rekommend',null,'rekommend logins');

        for (i=0; i < logins.length; i++) {
            if (logins[i].username == userid) {
                password = logins[i].password;
                break;
            }
        }
        
        var _onreadyfunc = function(e) {
            if (e.target.defaultView == e.target.defaultView.top && e.target.location) {
                Rek.browser.removeEventListener('DOMContentLoaded',_onreadyfunc,false);
                Rek.onReady(firstrun);
            }
        }
        Rek.browser.addEventListener('DOMContentLoaded',_onreadyfunc,false);

        // look for other windows to see if Rekommend is active there...
        // hide the sidebar-box until it loads
        var $sbb = $('#sidebar-box');
        var $sb = $('#sidebar');
        var hidden = $sbb.attr('hidden');
        $sbb.attr('hidden','true');
        var e = Rek.wm.getEnumerator('navigator:browser');
        var active = false;
        while(e.hasMoreElements()) {
            if (e.getNext().Rek.sidebar) {
                active = true;
                break;
            }
        }
        
        if (active && !hidden) {
            // hide the sidebar and do not login
            var _func = function() {
                //Rek.console.logStringMessage('DOMContentLoaded');
                $sb[0].removeEventListener("DOMContentLoaded",_func,true);
                if ($sb[0].contentWindow.location.href == 'chrome://rekommend/content/reksidebar.xul') {
                    $sbb.removeAttr('hidden');
                    toggleSidebar('viewREKSidebar');
                } else
                    $sbb.removeAttr('hidden');
            };
            $sb[0].addEventListener("DOMContentLoaded",_func,true);
            //Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
        } else {
            if (!hidden) $sbb.removeAttr('hidden');
            // if userid / password exists try to login
            if (userid && password && Rek.status) {
                Rek.console.logStringMessage('have userid and password - trying to login');
                Rek.login(userid,password,null,false);
            } else {
                // determine if there is an active facebook session (except on firstrun)
                if (!firstrun) {
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: Rek.getProperty('httpRequestRoot')+'xhr/fbsession.php',
                        dataType: 'text',
                        success: function(json){
                            //Rek.console.logStringMessage(json);
                            json = JSON.parse(json);
                            if (json.fb) {
                                // found a facebook session
                                Rek.fblogin(json.fb);
                            } else {
                                Rek.console.logStringMessage('no facebook session found');
                                Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
                            }
                        },
                        error: function(req,status,error){
                            // check on system status
                            Rek.validateStatus(Rek.CONST.STATUS_LOGGED_OUT);
                        }
                    });
                } else {
                    Rek.setStatus(Rek.CONST.FIRSTRUN);
                }
            }
        }
    },
    onReady: function(firstrun) {
        //this.log('DOM ready');
        //this.log(firstrun);
        if (firstrun) {
            toggleSidebar('viewREKSidebar',true);
        }
    },
    // login functions
    login: function(userid,password,callback,ignoreActive) {
        this.log('login attempt');
        var result = '';
        var logins = this.loginManager.findLogins({},'chrome://rekommend',null,'rekommend logins');
        if (userid && password) {
            // userid and password exist - log in
            this.lastLoginID = userid;
            this.lastLoginPass = password;
            Rek.log('get user record');
            $.ajax({
                type: 'POST',
                async: true,
                url: Rek.getProperty('httpRequestRoot')+'xhr/getUserRecord.php',
                data: {
                    userid:userid,
                    password:password,
                    ignore:ignoreActive
                },
                dataType: 'json',
                success: function(json){
                    Rek.log(json);
                    if (json.result == '0') { // returned ok
                        Rek.user.data = json.data[0];
                        Rek.user.id = Rek.user.data.id;
                        Rek.user.session = json.sessionId;
                        Rek.user.loginby = 'rek';
                        // preferences
                        Rek.log(Rek.user.data.preferences);
                        Rek.user.data.preferences = $.extend({},Rek.defaultPrefs(),Rek.user.data.preferences);
                        Rek.user.data.session = {};
                        // check for first run...
                        if (Rek.user.data.preferences['firstrun']) {
                            Rek.openURL('http://www.rekommend.com/quickstart.php','tab');
                            Rek.user.data.preferences['firstrun'] = 0;
                        }
                        Rek.db.putPrefs();
                        Rek.setStatus(Rek.CONST.STATUS_LOGGED_IN);
                    } else if (json.result == '1') {
                        // userid/password mismatch
                        result = Rek.getProperty('login.badLogin');
                        Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
                    } else if (json.result == '2') {
                        Rek.setStatus(Rek.CONST.STATUS_ACTIVE_SESSION);
                    } else {
                        result = Rek.getProperty('login.noDB');
                        Rek.validateStatus('db fail getUserRecord.php')
                    }
                    if (callback) callback.call(null,result); // callback with result
                },
                error: function(req,status,error){
                    // check on system status
                    Rek.validateStatus(status);
                }
            });

            // remember login credentials
            this.PREF.setCharPref('userid',userid);
            if (this.PREF.getBoolPref('remember')) {
                for (i = 0; i < logins.length; i++) {
                    if (logins[i].username == userid) {
                        var oldPassword = logins[i].password;
                        this.loginManager.removeLogin(new this.nsLoginInfo('chrome://rekommend',null,'rekommend logins',userid,oldPassword,'',''));
                    }
                }
                this.loginManager.addLogin(new this.nsLoginInfo('chrome://rekommend',null,'rekommend logins',userid,password,'',''));
            } else {
                // remove the prefs (but keep userid)
                for (var i=0; i<logins.length; i++) {
                    if (logins[i].username == userid) {
                        password = logins[i].password;
                        this.loginManager.removeLogin(new this.nsLoginInfo('chrome://rekommend',null,'rekommend logins',userid,password,'',''));
                    }
                }
            }
        } else {
            // insufficient credentials to login - show login page
            result = this.getProperty('login.missingField');
            if (this.sidebar) this.sidebar.show(this.CONST.SIDEBAR_LOGIN);
            if (callback) callback.call(null,result);
        }
    },
    fblogin: function(fb) {
        var self = this;
        // try to login with the current facebook session id
        $.ajax({
            type: 'POST',
            async: true,
            url: Rek.getProperty('httpRequestRoot')+'xhr/fblogin.php',
            data: {
                id:fb.id
            },
            dataType: 'json',
            success: function(json){
                Rek.log('fblogin result');
                Rek.log(json);
                if (json.result == 0) { // returned ok
                        Rek.user.data = json.data[0];
                        Rek.user.id = Rek.user.data.id;
                        Rek.user.session = json.sessionId;
                        Rek.user.loginby = 'facebook';
                        Rek.purgeLoginCredentials(json.data[0]);
                        // preferences
                        Rek.log(Rek.user.data.preferences);
                        Rek.user.data.preferences = $.extend({},Rek.defaultPrefs(),Rek.user.data.preferences);
                        Rek.user.data.session = {};
                        // check for first run...
                        if (Rek.user.data.preferences['firstrun']) {
                            Rek.openURL('http://www.rekommend.com/quickstart.php','tab');
                            Rek.user.data.preferences['firstrun'] = 0;
                        }
                        Rek.db.putPrefs();
                        Rek.setStatus(Rek.CONST.STATUS_LOGGED_IN);
                    } else {
                        Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
                    }
                    
            },
            error: function(req,status,error){
                // check on system status
                Rek.validateStatus(Rek.CONST.STATUS_LOGGED_OUT);
            }
        });
    },
    logout: function() {
        if (this.status != Rek.CONST.STATUS_LOGGED_OUT) {
            // clean up sidebar module caches,etc..
            if (Rek.sidebar) Rek.sidebar.onlogout();
            // clear user session
            if (Rek.user.id) {
                Rek.log('close user session');
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: Rek.getProperty('httpRequestRoot')+'xhr/closeUserSession.php',
                    data: {
                        id:Rek.user.id,
                        session:Rek.user.session
                    },
                    dataType: 'text',
                    success: function(json){
                        //Rek.log(json);
                        // clear user object
                        Rek.user = Rek.nullUser();
                        Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
                    },
                    error: function(req,status,error){
                        // check on system status
                        Rek.user = Rek.nullUser();
                        Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
                        //Rek.validateStatus(status);
                    }
                });
            } else {
                Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
            }
        }
    },
    purgeLoginCredentials: function(userid) {
        logins = Rek.loginManager.findLogins({},'chrome://rekommend',null,'rekommend logins');
        for (i=0; i < logins.length; i++) {
            if (logins[i].username == userid) {
                password = logins[i].password;
                Rek.loginManager.removeLogin(new Rek.nsLoginInfo('chrome://rekommend',null,'rekommend logins',userid,password,'',''));
            }
        }
        Rek.PREF.setCharPref('userid','');
        Rek.PREF.setBoolPref('remember',false);
    },
    setStatus: function(status) {
        // reset interval based on new status
        this.log('REK STATUS: '+status);
        if (this.pulse) clearInterval(this.pulse);
        var interval;
        switch (status) {
            case this.CONST.STATUS_UNAVAILABLE:
                interval = 5000;
                break;
            case this.CONST.STATUS_LOGGED_OUT:
                interval = 0;
                break;
            case this.CONST.STATUS_LOGGED_IN:
                interval = 30000;
                break;
            case this.CONST.STATUS_ACTIVE_SESSION:
                interval = 0;
                break;
            case this.CONST.STATUS_NOT_READY:
                interval = 0;
                break;
        }
        this.status = status;
        if (interval) this.pulse = setInterval(function(){
            Rek.doPulse();
        },interval);
        else this.pulse = null;
        if (this.sidebar) this.sidebar.init(); // init/re-init the sidebar if it is instantiated
    },
    sessionFailure: function() {
        if (this.sidebar) {
            this.sidebar.modal.openTimed({
                title:Rek.getProperty('rek.sessionBadTitle'),
                text:Rek.getProperty('rek.sessionBadText')
            });
        }
        // clear user object
        Rek.user = Rek.nullUser();
        Rek.setStatus(Rek.CONST.STATUS_LOGGED_OUT);
        // re-init the sidebar
        if (Rek.sidebar) Rek.sidebar.init();
    },
    // rek administration functions
    validateStatus: function(error) {
        this.log('validate status: '+error);
        // perform an ajax call to test for internet/db connection
        Rek.log('rek test');
        Rek.log(Rek.getProperty('httpRequestRoot')+'xhr/rektest.php');
        $.ajax({
            type: 'POST',
            async: true,
            url: Rek.getProperty('httpRequestRoot')+'xhr/rektest.php',
            dataType: 'text',
            success: function(json){
                Rek.log(json);
                //json = JSON.parse(json);
                if (Rek.user.id) {
                    Rek.setStatus(Rek.CONST.STATUS_LOGGED_IN);
                } else
                    if (error != 'init') Rek.logout();
            },
            error: function(req,status,error){
                //Rek.log(req);
                Rek.log(status);
                //Rek.log(error);
                Rek.setStatus(Rek.CONST.STATUS_UNAVAILABLE);
                if (Rek.sidebar) Rek.sidebar.show(Rek.CONST.SIDEBAR_UNAVAILABLE);
            }
        });
    },
    doPulse: function(cb) {
        Rek.log('pulse... status:'+Rek.status);
        if (!Rek.doSkipPulse) {
            switch (Rek.status) {
                case Rek.CONST.STATUS_UNAVAILABLE:
                    Rek.validateStatus('pulse');
                    break;
                case Rek.CONST.STATUS_LOGGED_OUT:
                    Rek.validateStatus('pulse');
                    break;
                case Rek.CONST.STATUS_LOGGED_IN:
                    if (Rek.sidebar) {
                        var requestArr = [{
                            id:'friend.friend',
                            crc: Rek.sidebar.friend.friendCrc
                        },{
                            id:'friend.sent',
                            crc: Rek.sidebar.friend.sentCrc
                        },{
                            id:'friend.inbox',
                            crc: Rek.sidebar.friend.inboxCrc
                        },{
                            id:'friend.social',
                            crc: Rek.sidebar.friend.socialCrc
                        }]
                        Rek.db.fetch(true,requestArr.concat(Rek.sidebar.browse.buildFetchArr(['browse.inbox','browse.comments','browse.bmark','browse.sent','browse.top100'])),cb);

                        // update preferences
                        if (Rek.user.data !== null) {
                            if (Rek.crc32(JSON.stringify(Rek.user.data.preferences)) != Rek.prefCrc) {
                                Rek.log('update preferences');
                                 Rek.db.putPrefs();
                            }
                        }
                    }
                    break;
                case Rek.CONST.STATUS_ACTIVE_SESSION:
                    break;
            }
        }
    },
    skipPulse: function() {
        this.doSkipPulse = true;
    },
    resumePulse: function() {
        this.doSkipPulse = false;
        //this.doPulse();
    },
    nullUser: function() {
        var user = {
            id:null,
            session:null,
            loginby:null,
            data:null,
            browse:{
                inbox:[],
                comments:[],
                bmark:[],
                sent:[],
                top100:[]
            },
            friend:{
                inbox:[],
                sent:[],
                friends:[],
                social:[]
            }
        };
        return user;
    },
    openPreferences: function() {
        if (null == this._preferencesWindow || this._preferencesWindow.closed) {
            var instantApply = Application.prefs.get("browser.preferences.instantApply");
            var features = "chrome,titlebar,toolbar,centerscreen" + (instantApply.value ? ",dialog=no" : ",modal");
            this._preferencesWindow =
            window.openDialog(
                "chrome://rekommend/content/rekprefs.xul",
                "rek-preferences", features, this);
        }
        this._preferencesWindow.focus();
    },
    defaultPrefs: function() {
        var prefs = {
            firstrun: 1,
            link: 'current',    // open links in
            se_mi: '',          // search
            se_al: '',          // search
            tree_sort: 'name',      // tree sort
            email_comment: 1,           // email new comment
            email_rek: 1,            // email new rek
            email_accept: 1,            // email new rek
            inbox_sort: 'date',
            inbox_twoline: '1',
            inbox_open: 'current',
            bmark_sort: 'date',
            bmark_twoline: '1',
            bmark_private: 'all',
            bmark_open: 'current',
            comments_twoline: '1',
            comments_open: 'current',
            sent_sort: 'date',
            sent_twoline: '1',
            sent_open: 'current',
            tag_sort: 'name'        // tag sort
        };
        return prefs;
    },
    
    // Shared APIs
    getCurrentURI: function() {
        return window.location.href;
    },
    openURL : function(url,where) {
        if (!where) {
            where = typeof Rek.user.data.preferences.link == 'undefined' ? 'current' : Rek.user.data.preferences.link;
        }
        Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow('navigator:browser').openUILinkIn(url,where);
    },
    openURLKey: function(key,where) {
        var url;
        url = Rek.getProperty('httpRequestRoot')+'r/'+key;
        Rek.openURL(url,where);
    },
    getProperty: function(sel) {
        return Rek.properties.getString(sel);
    },
    log: function(v) {
        if (Rek.CONST.DEBUG)
        try {
            Rek.browser.Firebug.Console.log(v);
        } catch (err) {
            Rek.console.logStringMessage(v.toString());
        }
    },
    appendDOMfromString: function($el,str) {
        var parser=new DOMParser();
        var doc;
        $.each($el,function(i,v){
            doc = parser.parseFromString('<document xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:html="http://www.w3.org/1999/xhtml">'+str+'</document>',"text/xml");
            $.each(doc.firstChild.childNodes,function(){
                $(v).append(doc.firstChild.childNodes[0]);
            });
            $(doc).remove();
        })
    },
    beforeDOMfromString: function($el,str) {
        var parser=new DOMParser();
        var doc;
        $.each($el,function(i,v){
            doc = parser.parseFromString('<document xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:html="http://www.w3.org/1999/xhtml">'+str+'</document>',"text/xml");
            $.each(doc.firstChild.childNodes,function(){
                $(v).before(doc.firstChild.childNodes[0]);
            });
            $(doc).remove();
        })
    },
    serializeDOM: function(el) {
        var s = new XMLSerializer();
        var str = s.serializeToString(el);
        return str;
    },
    // utility functions
    isNumberKeycode: function(keycode) {
        return ((keycode >= 48 && keycode <= 57) || (keycode >= 96 && keycode <= 105) || keycode == 8 || keycode == 9 || keycode == 13 || keycode == 14 || keycode == 46);
    },
    xmlEncode: function(str) {
        return str.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;').replace(/"/g,'&quot;');
    },
    xmlDecode: function(str) {
        return str.replace(/&amp;/g,'&').replace(/&lt;/g,'<').replace(/&gt;/g,'>').replace(/&quot;/g,'"');
    },
    htmlEncode: function(str) {
        return str.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
    },
    isEmail: function(str) {
        var pattern=/^([a-zA-Z0-9_.-])+@([a-zA-Z0-9_.-])+\.([a-zA-Z])+([a-zA-Z])+/;
        return (pattern.test(str));
    },
    isURL: function(str) {
        var pattern = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
        return pattern.test(str);
    },
    trim: function trim (str, charlist) {
        var whitespace, l = 0, i = 0;
        str += '';

        if (!charlist) {
            // default list
            whitespace = " \n\r\t\f\x0b\xa0\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u200b\u2028\u2029\u3000";
        } else {
            // preg_quote custom list
            charlist += '';
            whitespace = charlist.replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g, '$1');
        }

        l = str.length;
        for (i = 0; i < l; i++) {
            if (whitespace.indexOf(str.charAt(i)) === -1) {
                str = str.substring(i);
                break;
            }
        }

        l = str.length;
        for (i = l - 1; i >= 0; i--) {
            if (whitespace.indexOf(str.charAt(i)) === -1) {
                str = str.substring(0, i + 1);
                break;
            }
        }
        return whitespace.indexOf(str.charAt(0)) === -1 ? str : '';
    },
    explode: function(delimiter, string, limit) {
        var emptyArray = {
            0: ''
        };

        // third argument is not required
        if ( arguments.length < 2 ||
            typeof arguments[0] == 'undefined' ||
            typeof arguments[1] == 'undefined' ) {
            return null;
        }

        if ( delimiter === '' ||
            delimiter === false ||
            delimiter === null ) {
            return false;
        }

        if ( typeof delimiter == 'function' ||
            typeof delimiter == 'object' ||
            typeof string == 'function' ||
            typeof string == 'object' ) {
            return emptyArray;
        }

        if ( delimiter === true ) {
            delimiter = '1';
        }

        if (!limit) {
            return string.toString().split(delimiter.toString());
        } else {
            // support for limit argument
            var splitted = string.toString().split(delimiter.toString());
            var partA = splitted.splice(0, limit - 1);
            var partB = splitted.join(delimiter.toString());
            partA.push(partB);
            return partA;
        }
    },
    array_unique: function(inputArr) {
        var key = '', tmp_arr2 = {}, val = '';
        var __array_search = function (needle, haystack) {
            var fkey = '';
            for (fkey in haystack) {
                if (haystack.hasOwnProperty(fkey)) {
                    if ((haystack[fkey] + '') === (needle + '')) {
                        return fkey;
                    }
                }
            }
            return false;
        };
        for (key in inputArr) {
            if (inputArr.hasOwnProperty(key)) {
                val = inputArr[key];
                if (false === __array_search(val, tmp_arr2)) {
                    tmp_arr2[key] = val;
                }
            }
        }
        return tmp_arr2;
    },
    utf8Encode:function(string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },
    crc32:function (str) {

        str = Rek.utf8Encode(str);

        var table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

        var crc = 0;
        var x = 0;
        var y = 0;

        crc = crc ^ (-1);
        for (var i = 0, iTop = str.length; i < iTop; i++) {
            y = ( crc ^ str.charCodeAt( i ) ) & 0xFF;
            x = "0x" + table.substr( y * 9, 8 );
            crc = ( crc >>> 8 ) ^ x;
        }

        return crc ^ (-1);
    },
    md5:function (str) {
        // http://kevin.vanzonneveld.net
        // +   original by: Webtoolkit.info (http://www.webtoolkit.info/)
        // + namespaced by: Michael White (http://getsprink.com)
        // +    tweaked by: Jack
        // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
        // +      input by: Brett Zamir (http://brett-zamir.me)
        // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
        // -    depends on: utf8_encode
        // *     example 1: md5('Kevin van Zonneveld');
        // *     returns 1: '6e658d4bfcb59cc13f96c14450ac40b9'
        var xl;
        
        var rotateLeft = function (lValue, iShiftBits) {
            return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
        };
        
        var addUnsigned = function (lX, lY) {
            var lX4, lY4, lX8, lY8, lResult;
            lX8 = (lX & 0x80000000);
            lY8 = (lY & 0x80000000);
            lX4 = (lX & 0x40000000);
            lY4 = (lY & 0x40000000);
            lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
            if (lX4 & lY4) {
                return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
            }
            if (lX4 | lY4) {
                if (lResult & 0x40000000) {
                    return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
                } else {
                    return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
                }
            } else {
                return (lResult ^ lX8 ^ lY8);
            }
        };
        
        var _F = function (x, y, z) {
            return (x & y) | ((~x) & z);
        };
        var _G = function (x, y, z) {
            return (x & z) | (y & (~z));
        };
        var _H = function (x, y, z) {
            return (x ^ y ^ z);
        };
        var _I = function (x, y, z) {
            return (y ^ (x | (~z)));
        };
        
        var _FF = function (a, b, c, d, x, s, ac) {
            a = addUnsigned(a, addUnsigned(addUnsigned(_F(b, c, d), x), ac));
            return addUnsigned(rotateLeft(a, s), b);
        };
        
        var _GG = function (a, b, c, d, x, s, ac) {
            a = addUnsigned(a, addUnsigned(addUnsigned(_G(b, c, d), x), ac));
            return addUnsigned(rotateLeft(a, s), b);
        };
        
        var _HH = function (a, b, c, d, x, s, ac) {
            a = addUnsigned(a, addUnsigned(addUnsigned(_H(b, c, d), x), ac));
            return addUnsigned(rotateLeft(a, s), b);
        };
        
        var _II = function (a, b, c, d, x, s, ac) {
            a = addUnsigned(a, addUnsigned(addUnsigned(_I(b, c, d), x), ac));
            return addUnsigned(rotateLeft(a, s), b);
        };
        
        var convertToWordArray = function (str) {
            var lWordCount;
            var lMessageLength = str.length;
            var lNumberOfWords_temp1 = lMessageLength + 8;
            var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
            var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
            var lWordArray = new Array(lNumberOfWords - 1);
            var lBytePosition = 0;
            var lByteCount = 0;
            while (lByteCount < lMessageLength) {
                lWordCount = (lByteCount - (lByteCount % 4)) / 4;
                lBytePosition = (lByteCount % 4) * 8;
                lWordArray[lWordCount] = (lWordArray[lWordCount] | (str.charCodeAt(lByteCount) << lBytePosition));
                lByteCount++;
            }
            lWordCount = (lByteCount - (lByteCount % 4)) / 4;
            lBytePosition = (lByteCount % 4) * 8;
            lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
            lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
            lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
            return lWordArray;
        };
        
        var wordToHex = function (lValue) {
            var wordToHexValue = "",
            wordToHexValue_temp = "",
            lByte, lCount;
            for (lCount = 0; lCount <= 3; lCount++) {
                lByte = (lValue >>> (lCount * 8)) & 255;
                wordToHexValue_temp = "0" + lByte.toString(16);
                wordToHexValue = wordToHexValue + wordToHexValue_temp.substr(wordToHexValue_temp.length - 2, 2);
            }
            return wordToHexValue;
        };
        
        var x = [],
        k, AA, BB, CC, DD, a, b, c, d, S11 = 7,
        S12 = 12,
        S13 = 17,
        S14 = 22,
        S21 = 5,
        S22 = 9,
        S23 = 14,
        S24 = 20,
        S31 = 4,
        S32 = 11,
        S33 = 16,
        S34 = 23,
        S41 = 6,
        S42 = 10,
        S43 = 15,
        S44 = 21;
        
        str = Rek.utf8Encode(str);
        x = convertToWordArray(str);
        a = 0x67452301;
        b = 0xEFCDAB89;
        c = 0x98BADCFE;
        d = 0x10325476;
        
        xl = x.length;
        for (k = 0; k < xl; k += 16) {
            AA = a;
            BB = b;
            CC = c;
            DD = d;
            a = _FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
            d = _FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
            c = _FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
            b = _FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
            a = _FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
            d = _FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
            c = _FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
            b = _FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
            a = _FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
            d = _FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
            c = _FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
            b = _FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
            a = _FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
            d = _FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
            c = _FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
            b = _FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
            a = _GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
            d = _GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
            c = _GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
            b = _GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
            a = _GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
            d = _GG(d, a, b, c, x[k + 10], S22, 0x2441453);
            c = _GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
            b = _GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
            a = _GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
            d = _GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
            c = _GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
            b = _GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
            a = _GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
            d = _GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
            c = _GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
            b = _GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
            a = _HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
            d = _HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
            c = _HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
            b = _HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
            a = _HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
            d = _HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
            c = _HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
            b = _HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
            a = _HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
            d = _HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
            c = _HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
            b = _HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
            a = _HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
            d = _HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
            c = _HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
            b = _HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
            a = _II(a, b, c, d, x[k + 0], S41, 0xF4292244);
            d = _II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
            c = _II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
            b = _II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
            a = _II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
            d = _II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
            c = _II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
            b = _II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
            a = _II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
            d = _II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
            c = _II(c, d, a, b, x[k + 6], S43, 0xA3014314);
            b = _II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
            a = _II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
            d = _II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
            c = _II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
            b = _II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
            a = addUnsigned(a, AA);
            b = addUnsigned(b, BB);
            c = addUnsigned(c, CC);
            d = addUnsigned(d, DD);
        }
        
        var temp = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);
        
        return temp.toLowerCase();
    },
    inArray:function (needle, haystack, argStrict) {
        var key = '', strict = !!argStrict;
        if (strict) {
            for (key in haystack) {
                if (haystack[key] === needle) {
                    return true;
                }
            }
        } else {
            for (key in haystack) {
                if (haystack[key] == needle) {
                    return true;
                }
            }
        }
        return false;
    },
    date: function(format,timestamp) {
        var that = this,
        jsdate, f, formatChr = /\\?([a-z])/gi, formatChrCb,
        _pad = function (n, c) {
            if ((n = n + "").length < c) {
                return new Array((++c) - n.length).join("0") + n;
            } else {
                return n;
            }
        },
        txt_words = ["Sun", "Mon", "Tues", "Wednes", "Thurs", "Fri", "Satur",
        "January", "February", "March", "April", "May", "June", "July",
        "August", "September", "October", "November", "December"],
        txt_ordin = {
            1: "st",
            2: "nd",
            3: "rd",
            21: "st",
            22: "nd",
            23: "rd",
            31: "st"
        };
        formatChrCb = function (t, s) {
            return f[t] ? f[t]() : s;
        };
        f = {
            // Day
            d: function () { // Day of month w/leading 0; 01..31
                return _pad(f.j(), 2);
            },
            D: function () { // Shorthand day name; Mon...Sun
                return f.l().slice(0, 3);
            },
            j: function () { // Day of month; 1..31
                return jsdate.getDate();
            },
            l: function () { // Full day name; Monday...Sunday
                return txt_words[f.w()] + 'day';
            },
            N: function () { // ISO-8601 day of week; 1[Mon]..7[Sun]
                return f.w() || 7;
            },
            S: function () { // Ordinal suffix for day of month; st, nd, rd, th
                return txt_ordin[f.j()] || 'th';
            },
            w: function () { // Day of week; 0[Sun]..6[Sat]
                return jsdate.getDay();
            },
            z: function () { // Day of year; 0..365
                var a = new Date(f.Y(), f.n() - 1, f.j()),
                b = new Date(f.Y(), 0, 1);
                return Math.round((a - b) / 864e5) + 1;
            },

            // Week
            W: function () { // ISO-8601 week number
                var a = new Date(f.Y(), f.n() - 1, f.j() - f.N() + 3),
                b = new Date(a.getFullYear(), 0, 4);
                return 1 + Math.round((a - b) / 864e5 / 7);
            },

            // Month
            F: function () { // Full month name; January...December
                return txt_words[6 + f.n()];
            },
            m: function () { // Month w/leading 0; 01...12
                return _pad(f.n(), 2);
            },
            M: function () { // Shorthand month name; Jan...Dec
                return f.F().slice(0, 3);
            },
            n: function () { // Month; 1...12
                return jsdate.getMonth() + 1;
            },
            t: function () { // Days in month; 28...31
                return (new Date(f.Y(), f.n(), 0)).getDate();
            },

            // Year
            L: function () { // Is leap year?; 0 or 1
                var y = f.Y(), a = y & 3, b = y % 4e2, c = y % 1e2;
                return 0 + (!a && (c || !b));
            },
            o: function () { // ISO-8601 year
                var n = f.n(), W = f.W(), Y = f.Y();
                return Y + (n === 12 && W < 9 ? -1 : n === 1 && W > 9);
            },
            Y: function () { // Full year; e.g. 1980...2010
                return jsdate.getFullYear();
            },
            y: function () { // Last two digits of year; 00...99
                return (f.Y() + "").slice(-2);
            },

            // Time
            a: function () { // am or pm
                return jsdate.getHours() > 11 ? "pm" : "am";
            },
            A: function () { // AM or PM
                return f.a().toUpperCase();
            },
            B: function () { // Swatch Internet time; 000..999
                var H = jsdate.getUTCHours() * 36e2, // Hours
                i = jsdate.getUTCMinutes() * 60, // Minutes
                s = jsdate.getUTCSeconds(); // Seconds
                return _pad(Math.floor((H + i + s + 36e2) / 86.4) % 1e3, 3);
            },
            g: function () { // 12-Hours; 1..12
                return f.G() % 12 || 12;
            },
            G: function () { // 24-Hours; 0..23
                return jsdate.getHours();
            },
            h: function () { // 12-Hours w/leading 0; 01..12
                return _pad(f.g(), 2);
            },
            H: function () { // 24-Hours w/leading 0; 00..23
                return _pad(f.G(), 2);
            },
            i: function () { // Minutes w/leading 0; 00..59
                return _pad(jsdate.getMinutes(), 2);
            },
            s: function () { // Seconds w/leading 0; 00..59
                return _pad(jsdate.getSeconds(), 2);
            },
            u: function () { // Microseconds; 000000-999000
                return _pad(jsdate.getMilliseconds() * 1000, 6);
            },

            // Timezone
            e: function () {
                return 'UTC';
            },
            I: function () { // DST observed?; 0 or 1
                // Compares Jan 1 minus Jan 1 UTC to Jul 1 minus Jul 1 UTC.
                // If they are not equal, then DST is observed.
                var a = new Date(f.Y(), 0), // Jan 1
                c = Date.UTC(f.Y(), 0), // Jan 1 UTC
                b = new Date(f.Y(), 6), // Jul 1
                d = Date.UTC(f.Y(), 6); // Jul 1 UTC
                return 0 + ((a - c) !== (b - d));
            },
            O: function () { // Difference to GMT in hour format; e.g. +0200
                var a = jsdate.getTimezoneOffset();
                return (a > 0 ? "-" : "+") + _pad(Math.abs(a / 60 * 100), 4);
            },
            P: function () { // Difference to GMT w/colon; e.g. +02:00
                var O = f.O();
                return (O.substr(0, 3) + ":" + O.substr(3, 2));
            },
            T: function () {
                return 'UTC';
            },
            Z: function () { // Timezone offset in seconds (-43200...50400)
                return -jsdate.getTimezoneOffset() * 60;
            },

            // Full Date/Time
            c: function () { // ISO-8601 date.
                return 'Y-m-d\\Th:i:sP'.replace(formatChr, formatChrCb);
            },
            r: function () { // RFC 2822
                return 'D, d M Y H:i:s O'.replace(formatChr, formatChrCb);
            },
            U: function () { // Seconds since UNIX epoch
                return jsdate.getTime() / 1000 | 0;
            }
        };
        this.date = function (format, timestamp) {
            that = this;
            jsdate = (
                (typeof timestamp === 'undefined') ? new Date() : // Not provided
                (timestamp instanceof Date) ? new Date(timestamp) : // JS Date()
                new Date(timestamp * 1000) // UNIX timestamp (auto-convert to int)
                );
            return format.replace(formatChr, formatChrCb);
        };
        return this.date(format, timestamp);
    }
};

(function() {
    window.addEventListener("load", Rek.onload,false);
    window.addEventListener("unload", Rek.onunload,false);
}).apply(Rek);