var rekprefs = {
    Rek: null,
    onload: function() {
        rekprefs.init();
    },
    init: function() {
        // get the Rek object
        //var browser = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow('navigator:browser');
        //this.Rek = browser.Rek;
        //alert(arguments);
        //browser.Firebug.Console.log(window.arguments);
        this.Rek = window.arguments[0];

        // initalize preferences
        this.update(this.Rek.user.data.preferences);
    },
    update: function(p) {
        var Rek = this.Rek;
        // handle non-checkboxes
        $('.pref:not(checkbox)').each(function(i,v){
            var id = $(v).attr('id');
            v.value = p[id];
        });
        // handle checkboxes
        $('checkbox.pref').each(function(i,v){
            var id = $(v).attr('id');
            v.checked = p[id]?true:false;
        });
    },
    setDefault: function() {
        var p = this.Rek.defaultPrefs();
        this.update(p);
    },
    apply:function() {
        var Rek = this.Rek;
        // handle non-checkboxes
        $('.pref:not(checkbox)').each(function(i,v){
            var id = $(v).attr('id');
            Rek.user.data.preferences[id] = v.value;
        });
        // handle checkboxes
        $('checkbox.pref').each(function(i,v){
            var id = $(v).attr('id');
            Rek.user.data.preferences[id] = Number(v.checked);
        });
        Rek.db.putPrefs();
        window.close();
    }
};
